attribute highp		vec4	VertPos;

uniform		highp		mat4	WorldViewProj;
uniform		mediump	float	ContourOffset;
uniform		mediump	float	UVScale0;
uniform		highp	float	UVScale1;
uniform		highp		float	UVScale2;
uniform		highp		vec4	WarpOffset;
uniform		highp		vec4	ExtraOffset;
uniform		highp		float	WarpFactor;
uniform		highp		float	FogScale;
uniform		highp		float	FogSub;

varying		mediump	float	contourCoord;
varying		mediump	vec2	mainCoord;
varying		highp	vec2	detailCoord;
varying		highp		vec2	skyCoord;
varying		mediump	float	fog;

void main(void)
{
	highp	vec2	curveOffset = VertPos.xy-WarpOffset.xy;
	highp	float co = WarpFactor*(curveOffset.x*curveOffset.x+curveOffset.y*curveOffset.y);
	
	highp vec4	warpedPos = VertPos;
	if(warpedPos.z<0.0) warpedPos.z=0.0;
	warpedPos.z *= 0.5;
	warpedPos.z += 700.0;
	contourCoord	= 0.6-VertPos.z*1.0/1500.0;	// should be from VertPos
	
	warpedPos.z -= co;
	fog = 1.0-clamp((co-FogSub)*FogScale,0.0,1.0);
	gl_Position		= WorldViewProj * warpedPos;
	mainCoord			= VertPos.xy * UVScale0;
	detailCoord		= (VertPos.xy * UVScale1);//-ExtraOffset.xy;
	skyCoord			= (VertPos.xy * UVScale2)+ExtraOffset.xy;
}
