attribute highp		vec4	VertPos;

uniform		highp		mat4	WorldViewProj;
uniform		mediump	float	ContourOffset;
uniform		mediump	float	UVScale0;
uniform		mediump	float	UVScale1;
uniform		highp		float	UVScale2;
uniform		highp		vec4	WarpOffset;
uniform		highp		vec4	ExtraOffset;
uniform		highp		float	WarpFactor;
uniform		highp		float	FogScale;
uniform		highp		float	FogSub;

uniform		lowp		vec4	FogColour;
uniform		lowp		vec4	SunColour;


varying		mediump	vec2	mainCoord;
varying		mediump	vec2	detailCoord;

varying		lowp		vec4	FoggedSun;
varying		lowp		vec4	AddFog;

void main(void)
{
	highp	vec2	curveOffset = VertPos.xy-WarpOffset.xy;
	highp	float co = WarpFactor*(curveOffset.x*curveOffset.x+curveOffset.y*curveOffset.y);
	
	highp vec4	warpedPos = VertPos;
	highp float fogFactor = (co-FogSub)*FogScale;

	if(warpedPos.z < 0.0)
	{
		float depth = -warpedPos.z*0.001;
		fogFactor += depth;
	}

	warpedPos.z -= co;

	lowp float Fog = clamp(fogFactor,0.0,1.0);
	AddFog			= FogColour*Fog;
	FoggedSun		= SunColour*(1.0-Fog);
	
	gl_Position		= WorldViewProj * warpedPos;
	mainCoord			= VertPos.xy * UVScale0;
	detailCoord		= VertPos.xy * UVScale1;
}
