uniform sampler2D			Texture0;			// main texture, XYZ = light flatness grass 
uniform sampler2D			Texture1;			// '1D' contour ramp
uniform sampler2D			Texture2;			// detail with bump in alpha
uniform sampler2D			Texture3;			// cloud shadows

uniform		mediump	float	Adder;
uniform		mediump	float	Multiplier;

varying		mediump	float	contourCoord;
varying		mediump	vec2	mainCoord;
varying		highp	vec2	detailCoord;
varying		highp		vec2	skyCoord;

varying		lowp		vec4	FoggedSun;
varying		lowp		vec4	AddFog;


void main(void)
{	
	lowp	vec4	detRGMB			= texture2D(Texture2,detailCoord);//*tuneScale+tuneAdd;
	lowp	vec4	mainRGGvML 		= texture2D(Texture0,mainCoord);

//	lowp float cloudLight = clamp(2.0-(texture2D(Texture3, skyCoord).r+texture2D(Texture3, mainCoord).r),0.0,1.0);
//	lowp float cloudLight = clamp(1.5-(texture2D(Texture3, skyCoord).r),0.0,1.0);
	
	lowp 	float	detailGM = mix(detRGMB.z,detRGMB.y,mainRGGvML.z);

	lowp	float   howRocky = clamp((mainRGGvML.x+detRGMB.w+Adder)*Multiplier,0.0,1.0);
	
	lowp	vec4	rockColour = texture2D(Texture1, vec2(contourCoord-detRGMB.w*0.15, (5.0/16.0)),2.0)*detRGMB.x;
	lowp	vec4	gmColour = texture2D(Texture1, vec2(contourCoord, (3.0/16.0)-mainRGGvML.z*(1.0/8.0)),2.0)*detailGM;
	
	lowp	vec4	baseColour = mix(gmColour,rockColour,howRocky);
	
	lowp float light = mainRGGvML.a; //*cloudLight;
	
	lowp vec4 mixedColour = baseColour*light;
	gl_FragColor = mixedColour*FoggedSun+AddFog;

	
}
