attribute highp		vec4	VertPos;

uniform		highp		mat4	WorldViewProj;
uniform		mediump	float	UVScale0;
uniform		mediump	vec4	WarpOffset;
uniform		highp		float	WarpFactor;
uniform		highp		float	FogScale;
uniform		highp		float	FogSub;
uniform		highp		vec4	ExtraOffset;

varying		highp	vec2	mainCoord;
varying		highp	vec2	windCoord;

uniform		lowp		vec4	FogColour;
uniform		lowp		vec4	SunColour;

varying		lowp	vec4	DayContrib;
varying		lowp	vec4	NightContrib;
varying		lowp	vec4	FogContrib;

void main(void)
{
	highp	vec2	curveOffset = VertPos.xy;
	highp	float co = WarpFactor*(curveOffset.x*curveOffset.x+curveOffset.y*curveOffset.y);
	
	highp vec4	warpedPos = VertPos;
	warpedPos.z -= co;

	lowp float Fog	= clamp((co-FogSub)*FogScale,0.0,1.0);
	FogContrib			= FogColour*Fog;
	DayContrib			= FogColour*(1.0-Fog)*(1.0-SunColour.a);
	lowp float n		= (1.0-Fog)*(SunColour.a);
	NightContrib		= vec4(n,n,n,0.0);

	
	gl_Position		= WorldViewProj * warpedPos;
	mainCoord			= ((VertPos.xy+WarpOffset.xy) * UVScale0);
	windCoord			= ((VertPos.xy+WarpOffset.xy) * UVScale0) + ExtraOffset.xy;
}
