attribute highp		vec4	VertPos;

uniform		highp		mat4	WorldViewProj;
uniform		highp		float	UVScale0;
uniform		mediump	float	UVScale1;
uniform		highp		float	UVScale2;
uniform		highp		vec4	WarpOffset;
uniform		highp		vec4	ExtraOffset;
uniform		highp		vec4	ExtraOffset2;
uniform		highp		float	WarpFactor;
uniform		highp		float	FogScale;
uniform		highp		float	FogSub;
uniform		mediump	float	Time;

uniform		lowp		vec4	SunColour;
//uniform		lowp		vec4	AmbientColour;
uniform		lowp		vec4	WaterColour;
uniform		lowp		vec4	FogColour;


varying		mediump	vec2	detailCoord;
varying		mediump	vec2	rampCoord;
varying		lowp		vec4	FoggedWaterSun;
varying		lowp		vec4	AddFog;

void main(void)
{
	highp	vec2	curveOffset = VertPos.xy-WarpOffset.xy;
	highp	float co = WarpFactor*(curveOffset.x*curveOffset.x+curveOffset.y*curveOffset.y);
	
	//	highp vec2 wobble	= ((VertPos.xy * UVScale2*32.0)+ExtraOffset.xy*64.0)*(3.141592*2.0);
	highp vec2 wobble	= ((VertPos.xy * (1.0/2048.0)))*3.141592*2.0;
	
	float wave = sin(wobble.x)*sin(wobble.y);
	float upDown = 8.0*wave;
	
	highp vec4	warpedPos = VertPos;
	
	rampCoord.x = -(VertPos.z-upDown)*0.0033;
	rampCoord.y = Time+wave;
	
	warpedPos.z = upDown-co;
	
	lowp float Fog = clamp((co-FogSub)*FogScale,0.0,1.0);
	AddFog					= FogColour*Fog;
	FoggedWaterSun	= WaterColour*(1.0-Fog);
	
	gl_Position		= WorldViewProj * warpedPos;
	detailCoord		= VertPos.xy * UVScale1;
	
}
