attribute highp		vec4	VertPos;

uniform		highp		mat4	WorldViewProj;
uniform		highp		float	UVScale0;
uniform		mediump	float	UVScale1;
uniform		highp		float	UVScale2;
uniform		highp		vec4	WarpOffset;
uniform		highp		vec4	ExtraOffset;
//uniform		highp		vec4	ExtraOffset2;
uniform		highp		float	WarpFactor;
uniform		highp		float	FogScale;
uniform		highp		float	FogSub;
uniform		mediump	float	Time;

uniform		lowp		vec4	SunColour;
//uniform		lowp		vec4	AmbientColour;
uniform		lowp		vec4	WaterColour;
uniform		lowp		vec4	FogColour;


varying		mediump	vec2	detailCoord;
varying		mediump	vec2	rampCoord;
varying		lowp		vec4	FoggedWaterSun;
varying		lowp		vec4	AddFog;

void main(void)
{
	highp	vec2	curveOffset = VertPos.xy-WarpOffset.xy;
	highp	float co = WarpFactor*(curveOffset.x*curveOffset.x+curveOffset.y*curveOffset.y);
	
	highp vec4 cosscaler = vec4(6.28318530717959*3.0/8192.0,
											 6.28318530717959*5.0/8192.0,
											 6.28318530717959*7.0/8192.0,
											 6.28318530717959*11.0/8192.0);
	highp vec4 wobble	= VertPos.xyxy*cosscaler+ExtraOffset;
//	highp vec2 wobble2	= VertPos.xy*(6.28318530717959*50.0/8192.0)+ExtraOffset.zw;
	
	float wave = cos(wobble.x)*cos(wobble.y)*cos(wobble.z)*cos(wobble.w);
	float upDown = 30.0*wave;
	
	highp vec4	warpedPos = VertPos;
	
	rampCoord.x = -(VertPos.z-upDown)*0.003;
	rampCoord.y = Time+wave*0.25;
	
	warpedPos.z = upDown-co;
	
	lowp float Fog = clamp((co-FogSub)*FogScale,0.0,1.0);
	AddFog					= FogColour*Fog;
	FoggedWaterSun	= WaterColour*(1.0-Fog);
	
	gl_Position		= WorldViewProj * warpedPos;
	detailCoord		= VertPos.xy * UVScale1;
	
}
